package managedbeans;

import java.io.Serializable;

import javax.faces.event.ActionEvent;

import org.eclnt.jsfserver.elements.impl.FIXGRIDItem;
import org.eclnt.jsfserver.elements.impl.FIXGRIDListBinding;
import org.eclnt.jsfserver.session.RequestFocusManager;

public class DemoGrid01 implements Serializable {

	protected FIXGRIDListBinding<GridItem> m_grid = new FIXGRIDListBinding<GridItem>();

	public FIXGRIDListBinding<GridItem> getGrid() {
		return m_grid;
	}

	public void setGrid(FIXGRIDListBinding<GridItem> value) {
		m_grid = value;
	}

	private Long requestFocusFirstName;

	public Long getRequestFocusFirstName() {
		return requestFocusFirstName;
	}

	public void setRequestFocusFirstName(Long requestFocusFirstName) {
		this.requestFocusFirstName = requestFocusFirstName;
	}

	public DemoGrid01() {
		for (int i = 0; i < 10; i++) {
			GridItem row = new GridItem();
			row.setFirstName("First name " + (i + 1));
			row.setLastName("Last name " + (i + 1));
			m_grid.getItems().add(row);
		}
		// select the first item to be selected from the beginning on
		m_grid.selectItem(m_grid.getItems().get(0));
	}

	public class GridItem extends FIXGRIDItem implements java.io.Serializable {
		protected String m_lastName;

		public String getLastName() {
			return m_lastName;
		}

		public void setLastName(String value) {
			m_lastName = value;
		}

		protected String m_firstName;

		public String getFirstName() {
			return m_firstName;
		}

		public void setFirstName(String value) {
			m_firstName = value;
		}
	}

	public void onAdd(ActionEvent event) {
		m_grid.deselectCurrentSelection();
		GridItem item = addRow();
		m_grid.selectItem(item);
		m_grid.ensureItemToBeDisplayed(item);
		requestFocusFirstName = RequestFocusManager.getNewRequestFocusCounter();

	}

	private GridItem addRow() {
		GridItem row = new GridItem();
		int idx = m_grid.getItems().size();
		row.setFirstName("First name " + (idx + 1));
		row.setLastName("Last name " + (idx + 1));
		m_grid.getItems().add(row);
		return row;
	}

}
